<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Genero" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="GeneroSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.Genero;

			
			[Bindable]
			public var listaGenero: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			

			
			private var generoComponenteDetalhe: GeneroComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): Genero
			{
				var generoFiltro: Genero = new Genero();
				
				generoFiltro.descricao = ignTextInputDescricaoPesquisa.text == ""?null:"%" + ignTextInputDescricaoPesquisa.text + "%";
				return generoFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				
				
				var generoFiltro: Genero = new Genero();
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, generoFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaGenero: Page = event.result as Page;
				pageNumber = paginaGenero.pageNumber;
				totalRecords = paginaGenero.totalRecords;
				lastPage = paginaGenero.lastPage();
				listaGenero = paginaGenero.recordList;
				labelPaginaAtual.text = "" + paginaGenero.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaGenero.totalRecords;
			}

// CARREGANDO COMBOS			

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
					remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var generoComponenteCadastro: GeneroComponenteCadastro = new GeneroComponenteCadastro();
				generoComponenteCadastro.genero = new Genero(); 
				generoComponenteCadastro.addEventListener("GeneroIncluidoEvent", atualizarListaGeneroPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(generoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(generoComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var generoSelecionado: Genero = datagridListaGenero.selectedItem as Genero;
				this.dispatchEvent(new ResultEvent("GeneroSelecionadoEvent",false, true, generoSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaGenero_doubleClickHandler(event:MouseEvent):void
			{
				generoComponenteDetalhe = new GeneroComponenteDetalhe();
				generoComponenteDetalhe.genero = datagridListaGenero.selectedItem as Genero;
				generoComponenteDetalhe.addEventListener("GeneroExcluidoEvent", atualizarListaGeneroPorExclusaoResultHandler);
				generoComponenteDetalhe.addEventListener("GeneroAtualizadoEvent", atualizarListaGeneroPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(generoComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(generoComponenteDetalhe);
			}
			
			
			private function atualizarListaGeneroPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaGeneroPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaGeneroPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectGenero: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("generoService", listarResultHandler);	
				remoteObjectGenero.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descricao:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricaoPesquisa" styleName="labelValidacao" text="{ignTextInputDescricaoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricaoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaGenero"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaGenero}" doubleClick="datagridListaGenero_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="descricao" headerText="Descricao" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
